/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/****  Project : eXtended C Library (XCLIB)
    *  Purpose : ERROR HANDLING FACILITY
    *  Language: ANSI C
    *  File    : demo_error-1.c
    *  Author  : Martin Vicente <martin@vicente.org>
    *
    ****/


/*****************************************************************************\

 [English]

 [French]

 Pour avoir les messages d'erreur en couleur, il suffit de dfinir les
 variables d'environnement ERROR_COLOR et ERROR_BG_COLOR. Mes prfrences sont:

	ERROR_COLOR=Red
	ERROR_BG_COLOR=Black

 <1>	Uniquement pour la demo: en temps normal, il suffira juste de compiler
	avec `-D__DEBUG__' pour enrichir les messages.
 <2>	Optionnel: uniquement si on dsire distinguer cette couche logicielle
	dans les diffrents messages de trace.

\*****************************************************************************/


#undef	__DEBUG__		/*<1>*/
#define	__DEBUG__

#define _FACILITY	"demo"	/*<2>*/

#include <xc/error.h>

int main()
{
    warning("Can't open display");

#ifdef __MACRO_VARARGS__

    warning("Can't open display \"%s\"", "darkstar:0");

    puterr("DEBUG", "Can't open file %s", "~/.config");

    puterr("INFO", "It's %s time", "tea");

#else

    warning("Can't open display \"darkstar:0\"");

    puterr("DEBUG", "Can't open file ~/.config");

    puterr("INFO", "It's tea time");

#endif

    warning1("Can't open display \"%s\"", "darkstar:0");

    puterr1("DEBUG", "Can't open file %s", "~/.config");

    puterr1("INFO", "It's %s time", "tea");

    return 0;
}


/* End of file */
