/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/****  Project : eXtended C Library (XCLIB)
    *  Purpose : ERROR HANDLING FACILITY
    *  Language: ANSI C
    *  File    : demo_error-2.c
    *  Author  : Martin Vicente <martin@vicente.org>
    *
    ****/


/*****************************************************************************\

 [English]

 [French]

 Pour avoir les messages d'erreur en couleur, il suffit de dfinir les
 variables d'environnement ERROR_COLOR et ERROR_BG_COLOR. Mes prfrences sont:

	ERROR_COLOR=Red
	ERROR_BG_COLOR=Black

\*****************************************************************************/


#include <xc/error.h>

#define OK	0
#define ERROR	1

static int toolkit(void);
static int library(void);

int main()
{
    if (toolkit() == ERROR)
	return error("Can't open toolkit"), 1;

    return 0;
}

static int toolkit(void)
{
    if (library() == ERROR)
	return seterr("Can't load library"), ERROR;

    return OK;
}

static int library(void)
{
    if (1 /* an error */)
	return clrerr(), seterr("File not found"), ERROR;

    return OK;
}


/* End of file */
