/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	MATHDEFS:	MATHEMATIC DEFINES			     */


#ifndef __XC_MATHDEFS_H
#define __XC_MATHDEFS_H


/* Standard C Library: */
#include <math.h>

/* eXtended C Library: */
#include <xc/version.h>		/* VERSION OF EXTENDED C LIBRARY	     */


/**************************************
 *          STANDARD DEFINES          *
 **************************************/


#ifndef M_E
#define M_E		_XC_E			/* e		*/
#endif

#ifndef M_LOG2E
#define M_LOG2E		_XC_LOG2E		/* log_2(e)	*/
#endif

#ifndef M_LOG10E
#define M_LOG10E	_XC_LOG10E		/* log_10(e)	*/
#endif

#ifndef M_LN2
#define M_LN2		_XC_LN2			/* log_e(2)	*/
#endif

#ifndef M_LN10
#define M_LN10		_XC_LN10		/* log_e(10)	*/
#endif

#ifndef M_PI
#define M_PI		_XC_PI			/* pi		*/
#endif

#ifndef M_PI_2
#define M_PI_2		_XC_PI_2		/* pi/2		*/
#endif

#ifndef M_PI_4
#define M_PI_4		_XC_PI_4		/* pi/4		*/
#endif

#ifndef M_1_PI
#define M_1_PI		_XC_1_PI		/* 1/pi		*/
#endif

#ifndef M_2_PI
#define M_2_PI		_XC_2_PI		/* 2/pi		*/
#endif

#ifndef M_2_SQRTPI
#define M_2_SQRTPI	_XC_2_SQRTPI		/* 2/sqrt(pi)	*/
#endif

#ifndef M_SQRT2
#define M_SQRT2		_XC_SQRT2		/* sqrt(2)	*/
#endif

#ifndef M_SQRT1_2
#define M_SQRT1_2	_XC_SQRT1_2		/* 1/sqrt(2)	*/
#endif


#ifndef M_El
#define M_El		_XC_El			/* e		*/
#endif

#ifndef M_LOG2El
#define M_LOG2El	_XC_LOG2El		/* log_2(e)	*/
#endif

#ifndef M_LOG10El
#define M_LOG10El	_XC_LOG10El		/* log_10(e)	*/
#endif

#ifndef M_LN2l
#define M_LN2l		_XC_LN2l		/* log_e(2)	*/
#endif

#ifndef M_LN10l
#define M_LN10l		_XC_LN10l		/* log_e(10)	*/
#endif

#ifndef M_PIl
#define M_PIl		_XC_PIl			/* pi		*/
#endif

#ifndef M_PI_2l
#define M_PI_2l		_XC_PI_2l		/* pi/2		*/
#endif

#ifndef M_PI_4l
#define M_PI_4l		_XC_PI_4l		/* pi/4		*/
#endif

#ifndef M_1_PIl
#define M_1_PIl		_XC_1_PIl		/* 1/pi		*/
#endif

#ifndef M_2_PIl
#define M_2_PIl		_XC_2_PIl		/* 2/pi		*/
#endif

#ifndef M_2_SQRTPIl
#define M_2_SQRTPIl	_XC_2_SQRTPIl		/* 2/sqrt(pi)	*/
#endif

#ifndef M_SQRT2l
#define M_SQRT2l	_XC_SQRT2l		/* sqrt(2)	*/
#endif

#ifndef M_SQRT1_2l
#define M_SQRT1_2l	_XC_SQRT1_2l		/* 1/sqrt(2)	*/
#endif


/**************************************
 *          EXTENDED MATHDEF          *
 **************************************/


#undef	ONE
#undef	TEN
#undef	HUNDRED
#undef	THOUSAND
#undef	MILLION
#undef	BILLION
#
#define	ONE		1
#define	TEN		10
#define	HUNDRED		100
#define	THOUSAND	1000
#define	MILLION		1000000
#define	BILLION		1000000000


#undef	E
#define	E	M_E			/* MATHEMATICS: e */

#undef	PI
#define	PI	M_PI			/* MATHEMATICS: pi */


#undef	DEG2RAD
#define DEG2RAD	(_XC_PI/180.)
    
#undef	RAD2DEG
#define RAD2DEG	(180./_XC_PI)


#endif /* XC MATHDEFS HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
