/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	MISSING:	PROBABLY MISSING FUNCTIONS		     */


#ifndef __XC_MISSING_H
#define __XC_MISSING_H


/* Standard C Library: */
#include <stddef.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/* eXtended C Library: */
#include <xc/cdecl.h>		/* C DECLARATIONS			     */


_CDECL_BEGIN


#if defined __GLIBC__
#ifdef __STRICT_ANSI__
float fabsf(float x);
float atan2f(float y, float x);
#endif
#else
#define fabsf	__xclib(fabsf)
#define atan2f	__xclib(atan2f)
float __xclib(fabsf)(float x);
float __xclib(atan2f)(float y, float x);
#endif


#if defined _GNU_SOURCE && !defined __GLIBC__

int asprintf(char **pstr, const char *format, ...)
 __attribute__ ((__format__ (__printf__, 2, 3)));
int vasprintf(char **pstr, const char *format, va_list vargs)
 __attribute__ ((__format__ (__printf__, 2, 0)));

#endif


#ifdef __GLIBC__
#ifdef __STRICT_ANSI__
int snprintf(char *buf, size_t size, const char *format, ...)
 __attribute__ ((__format__ (__printf__, 3, 4)));
int vsnprintf(char *buf, size_t size, const char *format, va_list vargs)
 __attribute__ ((__format__ (__printf__, 3, 0)));
#endif
#else
#define snprintf	__xclib(snprintf)
#define vsnprintf	__xclib(vsnprintf)
#endif


int __xclib(snprintf)(char *buf, size_t size, const char *format, ...)
 __attribute__ ((__format__ (__printf__, 3, 4)));
int __xclib(vsnprintf)(char *buf, size_t size, const char *format, va_list vargs)
 __attribute__ ((__format__ (__printf__, 3, 0)));


#ifndef __GLIBC__

char *strdup(const char *s);

#endif


_CDECL_END


#endif /* XC MISSING HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
