/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	XALLOC:		PROTECTED MEMORY ALLOCATION FUNCTIONS	     */


#ifndef __XC_XALLOC_H
#define __XC_XALLOC_H


/* Standard C Library: */
#include <stddef.h>

/* eXtended C Library: */
#include <xc/cdecl.h>		/* C DECLARATIONS			     */


#define	xnew(ptrtype)	xmalloc(sizeof *(ptrtype)NULL)
#define xnewrec(type)	xmalloc(sizeof (type))


_CDECL_BEGIN

char *xstrdup(const char *s);
char *xstradd(char *s1, const char *s2);
void *xmemdup(const void *ptr, size_t size);
void *xmemadd(void *ptr1, size_t size1, const void *ptr2, size_t size2);

void *xmalloc(size_t size);
void *xcalloc(size_t n, size_t size);
void *xrealloc(void *ptr, size_t size);
void  xfree(void *ptr);

_CDECL_END


#endif /* XC XALLOC HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
