/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : SYNCHRONOUS I/O MULTIPLEXING (ADD-ON)
  | Version : 0.3
  | Language: ANSI C
  | File    : ioaux/sleep.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#define _FACILITY FACILITY(io)

#include <stddef.h>

#include <xc/time.h>
#include <xc/error.h>
#include <xc/io.h>

#include "xc/ioaux.h"

#include "global.h"

static void timer(IOTimerId id, IOTime *spec, IOData *data);

unsigned int io_sleep(unsigned int const sec)
{
    IOTime t, timeout;

    if (get_time(&t) == -1) fatal("Can't get time");

    if (put_time(&timeout, sec, 0, 0) == -1) fatal("Can't put time");

    if (add_time(&t, &timeout) == -1) fatal("Can't add time");

    io_add_timer(&t, timer, NULL);

    io_main_loop();

    return 0;
}

static void timer(UNUSED IOTimerId id, UNUSED IOTime *spec, UNUSED IOData *data)
{
    io_exit_loop();
}


/* End Of File */
