/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : MISSING FUNCTIONS
  | Version : 0.3
  | Language: ANSI C
  | File    : missing/asprintf.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

\*****************************************************************************/


#define _XCLIB_INTERNALS

#define _GNU_SOURCE

#include <stddef.h>
#include <stdarg.h>
#include <stdio.h>
#include <assert.h>

#ifdef __GLIBC__
#warning "xclib: *** asprintf() is already defined in GNU C Library"
#endif

#include "xc/missing.h"

#include "global.h"

int asprintf(char **pstr, const char *format, ...)
{
    va_list vargs;
    int     ret;

#if 0
    puts(__FUNC__ "()");
#endif

    assert(pstr != NULL && format != NULL);

    va_start(vargs, format);

    ret = vasprintf(pstr, format, vargs);

    va_end(vargs);

    return ret;
}


/* End Of File */
