/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : MISSING FUNCTIONS
  | Version : 0.3
  | Language: ANSI C
  | File    : missing/vsnprintf.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

\*****************************************************************************/


#define _XCLIB_INTERNALS

#include "missing/alloca.h"

#include <stddef.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#ifndef __GLIBC__

#include "xc/missing.h"

#include "global.h"

int __xclib(vsnprintf)(char *buf, size_t size, const char *format, va_list vargs)
{
    FILE *trash;
    int   ret;
    int   len;
    char *tmp;

#if 0
    puts(__FUNC__ "()");
#endif

    assert(format != NULL);

    trash = fopen("/dev/null", "w");

    if (trash == NULL) return -1;

    setbuf(trash, NULL);

    ret = vfprintf(trash, format, vargs);

    fclose(trash);

    len = ret;

    tmp = alloca(len + 1);

    if (tmp == NULL) return -1;

    ret = vsprintf(tmp, format, vargs);

    assert(ret == len);

    if (size >= (size_t)(len + 1))
    {
	strcpy(buf, tmp);
    }
    else if (size > 0)
    {
	strncpy(buf, tmp, size - 1);

	buf[size - 1] = '\0';
    }

    return len;
}

#endif /* GLIBC not defined */


/* End Of File */
