/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : PROGRAM INITIALIZATION
  | Version : 0.3
  | Language: ANSI C
  | File    : program/program.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

 [English]

 [French]

 Il ne s'agit pas ici de faire des trucs "sioux" ou d'en rajouter: il suffit
 simplement d'muler de manire aussi transparente que possible le comportement
 des deux variables `program_invocation_name' et
 `program_invocation_short_name' issues de l'implmentation GNU de la
 bibliothque C (GLIBC).

\*****************************************************************************/


#define _XCLIB_INTERNALS

#define _GNU_SOURCE

#include <errno.h>	/* `program_invocation_name', ... avec la lib C GNU */

#include "xc/program.h"
#
#undef program_invocation_name
#undef program_invocation_short_name

static char *program_name       = NULL;
static char *program_short_name = NULL;

#include "startup.h"
{
#ifdef __GLIBC__
    if (program_invocation_name != NULL)
    {
	program_name = program_invocation_name;
    }

    if (program_invocation_short_name != NULL)
    {
	program_short_name = program_invocation_short_name;
    }
#endif
}

char **__xcint(program_invocation_name_location)(void)
{
    return &program_name;
}

char **__xcint(program_invocation_short_name_location)(void)
{
    return &program_short_name;
}


/* End Of File */
