/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : STRING MANIPULATION LIBRARY
  | Version : 0.3
  | Language: ANSI C
  | File    : strlib/strupp.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

 [English]

 [French]

 Puisqu'il n'y a pas de recopie de la chane, si on avait crit

     char *c = s;

     while ((*c = toupper(*c)) != '\0') ++c;

 une boucle supplmentaire, pour '\0', aurait t ralise inutilement.

\*****************************************************************************/


#define _XCLIB_INTERNALS

#include <stddef.h>
#include <ctype.h>
#include <assert.h>

#include "xc/strlib.h"

#include "global.h"

char *strupp(char *const s)
{
    register char *pch;

    assert(s != NULL);

    for (pch = s; *pch != '\0'; ++pch) *pch = toupper((int)*pch);

    return s;
}


/* End Of File */
