#include <stddef.h>
#include <stdio.h>
#include <assert.h>

#include "xc/LListD.h"
#include "xc/xalloc.h"

typedef struct node *Node;
typedef struct list *List;

struct node
{
    struct node *next;
    struct node *prev;

    int data;
};

struct list
{
    struct node *head; /* heading sentinel */
    struct node *tail; /* leading sentinel */
};

static void print(struct list *list);

int main()
{
    struct list *list;
    struct node *node1;
    struct node *node2;
    struct node *node3;
    struct node *node4;
    struct node *node5;

    list = xnew(List);
    list->head = xnew(Node);
    list->tail = xnew(Node);
    LLD_INIT(list);
    print(list);

    (node1 = xnew(Node))->data = 1;
    LLD_APPEND(list, node1);
    print(list);

    (node2 = xnew(Node))->data = 2;
    LLD_APPEND(list, node2);
    print(list);

    (node3 = xnew(Node))->data = 3;
    LLD_APPEND(list, node3);
    print(list);

    (node4 = xnew(Node))->data = 4;
    LLD_INSERT(list, node4);
    print(list);

    (node5 = xnew(Node))->data = 5;
    LLD_INSERT_BEFORE(node5, node4);
    print(list);

    LLD_REMOVE(node5);
    xfree(node5);
    print(list);

    LLD_REMOVE(node3);
    xfree(node3);
    print(list);

    LLD_ACTION(list, xfree(__node););
    xfree(list->head);
    xfree(list->tail);
    xfree(list);

    return 0;
}

static void print(struct list *list)
{
    assert(list != NULL);

    fputs("List: (", stdout);

    LLD_FOREACH_NODE(list, printf(" %d", __node->data););

    puts(" )");
}
