#include <stddef.h>
#include <stdio.h>
#include <assert.h>

#include "xc/ListD.h"
#include "xc/xalloc.h"

struct node
{
    struct node *next;

    int data;
};

struct list
{
    struct node head; /* heading sentinel */
    struct node tail; /* leading sentinel */
};

static void print(struct list *list);

int main()
{
    struct list *list;
    struct node *node1;
    struct node *node2;
    struct node *node3;
    struct node *node4;
    struct node *node5;

    list = xnewrec(struct list);
    _LD_INIT(&list->head, &list->tail);
    print(list);

    (node1 = xnewrec(struct node))->data = 1;
    _LD_APPEND(&list->head, &list->tail, node1);
    print(list);

    (node2 = xnewrec(struct node))->data = 2;
    _LD_APPEND(&list->head, &list->tail, node2);
    print(list);

    (node3 = xnewrec(struct node))->data = 3;
    _LD_APPEND(&list->head, &list->tail, node3);
    print(list);

    (node4 = xnewrec(struct node))->data = 4;
    _LD_INSERT(&list->head, &list->tail, node4);
    print(list);

    (node5 = xnewrec(struct node))->data = 5;
    _LD_INSERT(&list->head, &list->tail, node5);
    print(list);

    assert(node5 != &list->head && node5 != &list->tail);
    _LD_REMOVE(&list->head, &list->tail, node5);
    xfree(node5);
    print(list);

    assert(node3 != &list->head && node3 != &list->tail);
    _LD_REMOVE(&list->head, &list->tail, node3);
    xfree(node3);
    print(list);

    _LD_ACTION(&list->head, &list->tail, xfree(__node););
    xfree(list);

    return 0;
}

static void print(struct list *list)
{
    assert(list != NULL);

    fputs("List: (", stdout);

    _LD_FOREACH_NODE(&list->head, &list->tail,
    {
	printf(" %d", __node->data);
    });

    puts(" )");
}
